// AMSLER GRID ASSISTED MACULAR DEGENERATION VISOION CORRECTION
// http://www.opt.indiana.edu/riley/HomePage/Amsler_Grid/4TEXTamsler_grid.html
//
// move (drag/drop) the grid vertices
// pressing "ENTER" shows the image, distorted/corrected round the focus (red)
// pressing "SPACE" makes the distortion/correction dynamic around the curser (yellow)
//

//import controlP5.*;
//ControlP5 controlP5;
//import processing.video.*;
//Capture video;
//686

public int CSize=750, NGL=21, SSf=16, SSa=8; //CANVAS SIZE, grid lines, fosuc spot size, active vertex spot size 
public int ixA, jyA, iC, jC, imS, LineWidth=1,iImage=0,Invert=1,Nfiles=0,Npics=0,eyeIndex=0;
public float xA,yA,xn,yn,imSc,xoff,yoff,x2,y2,fade=1,CellSize = CSize/NGL;
public float[][] xVec, yVec, xVecR, yVecR, xVecL, yVecL;
public int[] imageWidths, imageHeights;
public boolean bover = false, locked = false; //booleans needed for vertex mouse dragging
public boolean ToggleMorph=false, CameraExists=false, ToggleDynamic=false; //Toggles for Dynamic mode, Image Display

float x,y,dx=CSize/(NGL-1),R=dx/2,D,minD,ii,ji;
int i,j,xi,yi, redC, alphaC, greenC, blueC;
PImage imBG=createImage(CSize,CSize,RGB); 
PImage xVecS=createImage(NGL,NGL,ARGB), yVecS=createImage(NGL,NGL,ARGB), eyeL, eyeR;
PImage[] pics;

//Start-Up Routine, runs before continiously excecuted draw-routine
void setup(){
 size(CSize,CSize); //canvas size
 background(255); //background color
 smooth();
 
 //eye images
  eyeL = loadImage("eyeL.png");
  eyeR = loadImage("eyeR.png");
 
 //Arrays storing Amseler grid vertces x- and y-coordinates
  xVec = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores x-coordinates of vertices 
  yVec = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores y-coordinates of vertices
  xVecL = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores x-coordinates of vertices, Left Eye 
  yVecL = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores y-coordinates of vertices, Left Eye
  xVecR = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores x-coordinates of vertices, Right Eye
  yVecR = new float[NGL][NGL]; //2D-array of size (NGL x NGL), stores y-coordinates of vertices, Right Eye
  
  //load all images from directory 
    String path = sketchPath + "/data/"; //set image files path
    File[] files = listFiles(path); //stores files
    Nfiles = files.length; j=0; //number of files in directory
    for(int i=0; i<Nfiles; i++) {
      if(files[i].getName().endsWith(".jpg")) {
        Npics = Npics+1; //count .jpg-images
      }
    }
    pics = new PImage[Npics]; //picture array
    imageWidths = new int[Npics]; //picture widths
    imageHeights = new int[Npics]; //picture heights
    
    for(int i=0; i<Nfiles; i++) {
       if(files[i].getName().endsWith(".jpg")) {
         pics[j] = loadImage(files[i].getName());
         imageWidths[j] = pics[j].width;
         imageHeights[j] = pics[j].height;
         print("image index: "); print(j); print(", size: "); print(imageWidths[j]); print(", path: "); println(files[i]);
         j=j+1;
       }
    } 
 
 //Initialize undistorted Amsler Grid
  for (i=0; i<NGL; i=i+1) {
    for (j=0; j<NGL; j=j+1) {
       xVec[i][j]=i*dx;
       yVec[i][j]=j*dx;
       //duplicate for left and right eye arrays
         xVecL[i][j]=xVec[i][j]; yVecL[i][j]=yVec[i][j];
         xVecR[i][j]=xVec[i][j]; yVecR[i][j]=yVec[i][j];
     }
  }
 
 //coordinates of center of Amsler grid
  iC = floor(NGL/2);
  jC = floor(NGL/2);
}

void draw(){
  //setup canvas and set colorspace to be RGB with values between 0 and 1
  colorMode(RGB,1,1,1,1);
  ellipseMode(CENTER); //draws cirles, uses center coordinates
  if (ToggleMorph==true) {
    background(imBG);
  } else {
    background(Invert,Invert,Invert,1); //black or white background
  }
    
  if (ToggleDynamic==false) {
    minD=200;  
    strokeWeight(LineWidth); stroke(1-Invert,1-Invert,1-Invert,1);
    //go through all vertices, i.e. first and second index of grid vertex arrays.
    for (i=0; i<NGL; i=i+1) {
      for (j=0; j<NGL; j=j+1) {
        //find active vertex
        D = sqrt(pow(xVec[i][j] - mouseX,2) + pow(yVec[i][j] - mouseY,2)); //vertex distance to curser
        if (D < minD) {
          xA = xVec[i][j]; ixA = i; //vertex under mouse curser: x-coordinate, and first index 
          yA = yVec[i][j]; jyA = j; //vertex under mouse curser: y-coordinate, and second index
          minD = D; //remember so far closest vertex distance to curser position
        }
        //draw 2 grid lines per vertex
        if ((i<NGL-1) && (j<NGL-1)) {
          line(xVec[i][j],yVec[i][j],xVec[i+1][j],yVec[i+1][j]);
          line(xVec[i][j],yVec[i][j],xVec[i][j+1],yVec[i][j+1]);
        } else if ((i == NGL-1) && (j < NGL-1)) {
          line(xVec[i][j],yVec[i][j],xVec[i][j+1],yVec[i][j+1]); //only vertical line in last column 
        } else if ((j == NGL-1) && (i < NGL-1)) {
          line(xVec[i][j],yVec[i][j],xVec[i+1][j],yVec[i+1][j]); //only horizontal line in last row
        }
      }
    }
    //Draw center point to focus on!
      noStroke(); fill(1,0,0,1); //red color filling
      ellipse(xVec[iC][jC],yVec[iC][jC],SSf,SSf);
    //highlight active vertex with yellow spot
      fill(1,1,0,1); //blue color filling
      ellipse(xVec[ixA][jyA],yVec[ixA][jyA],SSa,SSa);
  } else {
      //Draw mouse curser position as yellow spot
      fade = fade/1.4;
      fill(1,0,0,fade); //blue color filling
      ellipse(mouseX,mouseY,SSa,SSa);
  }
  
  //needed for particle dragging
    if (mouseX > xA-R && mouseX < xA+R && mouseY > yA-R && mouseY < yA+R) {
      bover = true;  
    } else {
      bover = false;
    }
    
  //Start Morphing using the Amsler grid data
  noStroke();
  if (ToggleMorph==true) {
     imBG.loadPixels();
     print(iImage);
     pics[iImage].loadPixels();
     setBackground(pics[iImage]);   
     
     if (ToggleDynamic==true) {
       x2 = mouseX - CSize/2;
       y2 = mouseY - CSize/2;
       fill(0,1);
       text("Dynamische Korrektur",10,20);
     } else {
       x2 = 0;
       y2 = 0; 
     }
            
     for (xi=0; xi<CSize; xi=xi+1) {
        for (yi=0; yi<CSize; yi=yi+1) {
            ii = (xi-x2)/dx;
            ji = (yi-y2)/dx;
            if ((ii>0) && (ii<NGL-1) && (ji>0) && (ji<NGL-1)) {
              xoff = (xi - x2) - Interp2D(xVec, ii, ji);
              yoff = (yi - y2) - Interp2D(yVec, ii, ji);
              if ((round(xi+xoff) > 0) && (round(xi+xoff) < imageWidths[iImage]) && (round(yi+yoff) > 0) && (round(yi+yoff) < imageHeights[iImage])) {
                imBG.pixels[xi+yi*CSize] = pics[iImage].pixels[round(xi+xoff)+round(yi+yoff)*imageWidths[iImage]];
              }
            }
        }
     }
  }
  
  // eyeIndex = 0: Left Eye, eyeIndex = 1: Right Eye
  fill(1-Invert,1);
  if (eyeIndex == 0) {
    tint(1,1.0); image(eyeL,CSize-200,20);
    tint(1,0.2); image(eyeR,CSize-100,20);
    text("Linkes Auge",CSize-200,17);
  } else {
    tint(1,0.2); image(eyeL,CSize-200,20);
    tint(1,1.0); image(eyeR,CSize-100,20);
    text("Rechtes Auge",CSize-100,17);
  }
}

void mouseDragged() {
  if(locked) {
    xVec[ixA][jyA] = mouseX-xn; //drag Vertex, x
    yVec[ixA][jyA] = mouseY-yn; //drag Vertex, y
  }
}

void mousePressed() {
  //Toggle Locked state, needed for dragging
  if(bover) { 
    locked = true; 
  } else {
    locked = false;
  }
  xn = mouseX - xA; // needed for dragging in x
  yn = mouseY - yA; // needed for dragging in y
}

float signum(float f) {
  if (f > 0) return 1.0;
  if (f < 0) return -1.0;
  return 0;
}

//Key press events
void keyPressed() {
  if (key == RETURN || key == ENTER) {
      ToggleMorph = !ToggleMorph; //pressing enter
  }
  if (key == 'i') {
      Invert = (Invert + 1) % 2; //pressing enter
      print(Invert);
  }
  if (key == ' ') {
      ToggleDynamic = !ToggleDynamic; //pressing space bar
  }
  if (key == 'l') {
      loadData();
  }
  if (key == 's') {
      saveData();
  }
  if (key == 'a') {
      eyeIndex = (eyeIndex + 1) % 2; //0: left eye, 1: right eye
      if (eyeIndex == 0) {
        //save right eye
          arrayCopy(xVec, xVecR); //arrayCopy(src, dest);
          arrayCopy(yVec, yVecR);
        //load left eye
          arrayCopy(xVecL, xVec); 
          arrayCopy(yVecL, yVec);
        print(" saved right eye, loaded left eye ");
      } else {
        //save left eye
          arrayCopy(xVec, xVecL); 
          arrayCopy(yVec, yVecL);
        //load right eye
          arrayCopy(xVecR, xVec); 
          arrayCopy(yVecR, yVec);
        print(" saved left eye, loaded right eye ");
      }
  }
  
  if (ToggleMorph == true) {
    if (key == '+') {
      iImage = (iImage + 1) % Npics; //pressing "+" takes next image
    }
    if (key == '-') {
      iImage = abs((iImage - 1) % Npics); //pressing "-" takes previous image
    }
  } else {
    if (key == '+') {
      LineWidth = LineWidth + 1; //pressing "+" makes lines thicker
    }
    if (key == '-') {
      LineWidth = LineWidth - 1; //pressing "-" makes lines thinner
      if (LineWidth < 1) {
        LineWidth = 1;
      }
    }
  }
  
}

//called whenever mouse is moved
void mouseMoved() {
  fade=1;
}

// interpolates 2D-array data[i][j] to data[ii][ji]  
// algorithm adapted from http://en.wikipedia.org/wiki/Bilinear_interpolation
float Interp2D(float[][] data, float ii, float ji) {
  int i1 = floor(ii), i2=i1+1; 
  int j1 = floor(ji), j2=j1+1;
  float datai=0, normd=(i2-i1)*(j2-j1);
  datai = (data[i1][j1]/normd) * (i2-ii)*(j2-ji);
  datai = datai + (data[i2][j1]/normd) * (ii-i1)*(j2-ji);
  datai = datai + (data[i1][j2]/normd) * (i2-ii)*(ji-j1);
  datai = datai + (data[i2][j2]/normd) * (ii-i1)*(ji-j1);
  
  return datai;
}

//taken from http://processing.org/learning/topics/directorylist.html
//Read in list of files in a given directory
File[] listFiles(String dir) {
 File file = new File(dir);
 if (file.isDirectory()) {
   File[] files = file.listFiles();
   return files;
 } else {
   // If it's not a directory
   return null;
 }
}

//sets PImage picture to background
float setBackground(PImage picture) {
   picture.loadPixels();
   imBG.loadPixels();
   for (xi=0; xi<CSize; xi=xi+1) {
     for (yi=0; yi<CSize; yi=yi+1) {
       if (xi < picture.width && yi < picture.height) {
         imBG.pixels[xi + yi*CSize] = picture.pixels[xi + yi*picture.width];
       } else {
         imBG.pixels[xi + yi*CSize] = picture.pixels[picture.height*picture.width-1];
         //take color of last point in last row
       }
     }
   }
   return 1.0;
}

//SAVE AND LOAD 2D Array of positions into Image and save / load that image
float saveData() {
  colorMode(RGB,255,255,255,255);
  xVecS.loadPixels(); yVecS.loadPixels();
  for (i=0; i<NGL; i=i+1) {
    for (j=0; j<NGL; j=j+1) {
      //store x-coordinates in image red and alpha channel
        x = xVec[i][j] - i*dx; //offset of vertex (i,j)
        blueC = round(signum(x)+1); //sign of offset at vertex (i,j)
        x = abs(x); //absolute offset
        redC = floor(x*255.0/CellSize);
        xVecS.pixels[i+j*NGL] = color(redC,0,blueC,redC);
      //store y-coordinates in image red and alpha channel
        y = yVec[i][j] - j*dx;
        blueC = round(signum(y)+1);
        y = abs(y);
        redC = floor(y*255.0/CellSize);
        yVecS.pixels[i+j*NGL] = color(redC,0,blueC,redC);
     }
  }
  if (eyeIndex == 0) { 
    xVecS.save("xVecL.png");
    yVecS.save("yVecL.png");
  } else {
    xVecS.save("xVecR.png");
    yVecS.save("yVecR.png");
  } 
  print("saved data to files ");
  return 1.0;
}

float loadData() {
  colorMode(RGB,255,255,255,255);
  if (eyeIndex == 0) {
    xVecS = loadImage("xVecL.png");
    yVecS = loadImage("yVecL.png");
  } else {
    xVecS = loadImage("xVecR.png");
    yVecS = loadImage("yVecR.png");
  }
  xVecS.loadPixels(); 
  yVecS.loadPixels();
  for (i=0; i<NGL; i=i+1) {
    for (j=0; j<NGL; j=j+1) {
       color cx = xVecS.pixels[i+j*NGL];
       color cy = yVecS.pixels[i+j*NGL];
       xVec[i][j] = i*dx + (blue(cx) - 1)*red(cx)*CellSize/255.0; //+ green(xVecS.pixels[i+j*NGL])/255.0;
       yVec[i][j] = j*dx + (blue(cy) - 1)*red(cy)*CellSize/255.0; // + green(yVecS.pixels[i+j*NGL])/255.0;
     }
  }
  print("loaded data from files ");
  return 1.0;
}
